(function () {
    'use strict';
    var myApp = angular.module('myApp', ['onsen.directives']);

    var STATICURL = 'http://panel.deliverymas.com';
    var URL = STATICURL + '/api';
    var API_LATLNG = 'http://maps.googleapis.com/maps/api/geocode/json?&sensor=true_or_false&latlng=';

    var httpConfig = {};
    var version = 10011;
    // valor en milisegundos en que un perfil es valido, si supera se vuelve a traer los valores
    var profileTimeValid = 3600000; // una hora
    var posicion = {
        "actual": null,
        "nueva": null
    };

    var SimpleHttpClient = function() {
        this.get = function(aUrl, aCallback) {
            var anHttpRequest = new XMLHttpRequest();
            anHttpRequest.onreadystatechange = function() {
                if (anHttpRequest.readyState == 4 && anHttpRequest.status == 200)
                    aCallback(anHttpRequest.responseText);
            }

            anHttpRequest.open( "GET", aUrl, true );
            anHttpRequest.send( null );
        }
    }

    myApp.run(function ($window, $rootScope) {
        /*$rootScope.online = navigator.onLine;*/
        /*$window.addEventListener("offline", function () {
            $rootScope.$apply(function () {
                $rootScope.online = false;
            });
        }, false);
        $window.addEventListener("online", function () {
            $rootScope.$apply(function () {
                $rootScope.online = true;
            });
        }, false);*/
    });

    myApp.value('usuario', {
        value: null
    });

    function log(i) {
        console.log(i);
    }

    function searchById(a, o) {
        var r = -1;
        for (var i = 0; i < a.length; i++) {
            //if( a[i].name === o.name){
            if (a[i].nombre === o.nombre) {
                r = i;
            }
        }
        return r;
    }

    function searchByRealId(a, o) {
        var r = -1;
        var ids = [];
        for (var i = 0; i < a.length; i++) {
            //if( a[i].name === o.name){
            ids.push(a[i].id);
            if (a[i].id === o.id) {
                r = i;
                break;
            }
        }
        return r;
    }

    function getMessageAgregadosSabores(detalle) {
        var message = '', lista, i;
        if (detalle.extras && detalle.extras.length > 0) {
            lista = detalle.extras;
            var ttipo = '';
            for (i = lista.length - 1; i >= 0; i--) {
                if (lista[i].tipo == 0) {
                    ttipo = "Agregar - ";
                } else if (lista[i].tipo == 1) {
                    ttipo = "Quitar - ";
                }
                message += ttipo + '\x09' + lista[i].nombre + '\n';
            }
        } else if (detalle.selsabores && detalle.selsabores.length > 0) {
            lista = detalle.selsabores;
            var ssabor = '';
            for (i = lista.length - 1; i >= 0; i--) {
                ssabor = "Sabor - ";
                //if(lista[i].tipo == 0){ttipo = "Agregar - ";}else if(lista[i].tipo == 1){ttipo = "Quitar - ";}
                message += ssabor + '\x09' + lista[i].nombre + '\n';
            }
        }
        return message;
    };

    myApp.service('sharedProperties', function () {
        var hashtable = {};
        return {
            setValue: function (key, value) {
                hashtable[key] = value;
            },
            getValue: function (key) {
                return hashtable[key];
            }
        }
    });

    myApp.factory('store', function () {
        var validarAbiertoEnRango = function() {
            var store = this;
            if (!store.store.abierto || !store.store.enrango) {
                if (!store.store.abierto) {
                    swal({
                        title: "Lo sentimos!",
                        text: "El negocio se encuentra fuera del horario de atención.",
                        type: "warning",
                        confirmButtonText: "Aceptar"
                    });
                } else if (store.store.enrango == undefined) {
                    // TODO: Analizar eliminar este caso, ya no se cumple nunca.
                    swal({
                        title: "Lo sentimos!",
                        text: "No ha seleccionado ningún destino.",
                        type: "warning",
                        confirmButtonText: "Aceptar"
                    });
                } else {
                    swal({
                        title: "Lo sentimos!",
                        text: "El negocio se encuentra fuera del area de cobertura.",
                        type: "warning",
                        confirmButtonText: "Aceptar"
                    });
                }
                return false;
            }
            return true;
        };

        return {
            data: null,
            products: null,
            combos: null,
            store: null,
            rubro: null,
            combo: null,
            validarAbiertoEnRango: validarAbiertoEnRango
        };
    });

    myApp.factory('comboFactory', function () {
        var combo = null;

        var setCombo = function(combo) {
            var combo_org = combo;
            combo = JSON.parse(JSON.stringify(combo));
            combo.original = combo_org;
            combo.cantidad = 0;
            if (!combo.original.cantidad)
                combo.original.cantidad = 0;
            for (var i = 0; i < combo.grupos.length; i++) {
                var grupo = combo.grupos[i];
                combo.cantidad += grupo.cantidad;
                for (var j = 0; j < grupo.componentes.length; j++) {
                    var componente = grupo.componentes[j];
                    componente.cantidad_seleccionada = 0;
                    //
                    componente.grupo = grupo;
                }
                //
                grupo.cantidad_seleccionada = function() {
                    var cantidad = 0;
                    for (var j = 0; j < this.componentes.length; j++) {
                        cantidad += this.componentes[j].cantidad_seleccionada;
                    }
                    return cantidad;
                };
                grupo.combo = combo;
            }
            //
            combo.cantidad_seleccionada = function() {
                var cantidad = 0;
                for (var i = 0; i < combo.grupos.length; i++) {
                    cantidad += this.grupos[i].cantidad_seleccionada();
                }
                return cantidad;
            };
            this.combo = combo;
        };

        var getComboCarrito = function() {
            if (!this.combo)
                return null;
            var combo = this.combo;
            var combo_carrito = this.combo.original;
            var seleccion = [];
            for (var i = 0; i < combo.seleccion.length; i++) {
                var componente = combo.seleccion[i];
                componente.producto.cantidad = componente.cantidad_seleccionada;
                seleccion.push(componente.producto);
            }
            combo_carrito.seleccion = seleccion;
            return combo_carrito;
        };

        return {
            combo: combo,
            setCombo: setCombo,
            getComboCarrito: getComboCarrito
        }
    });

    myApp.factory('carrito', function (store) {
        var data = null;

        var addProducto = function(producto) {
            var carrito = this;
            producto = JSON.parse(JSON.stringify(producto));

            if (!producto.extras && !producto.selsabores) {
                var i = searchById(carrito.data.products, producto);
                if (i == -1) {
                    producto.cantidad = 1;
                    carrito.data.products.push(producto);
                } else {
                    carrito.data.products[i].cantidad++;
                }
            } else {
                if (producto.selsabores) {
                    var selsaboresprecio = 0;
                    for (var i = producto.selsabores.length - 1; i >= 0; i--) {
                        selsaboresprecio += producto.selsabores[i].precio;
                    }
                    producto.precio = Math.round(selsaboresprecio / producto.selsabores.length);
                }

                if (producto.extras) {
                    for (var i = producto.extras.length - 1; i >= 0; i--) {
                        producto.precio += producto.extras[i].precio;
                    }
                }

                producto.cantidad = 1;
                carrito.data.products.push(producto);
            }

            carrito.data.cantidad++;
            carrito.data.total += producto.precio;

            if (searchById(store.products, producto) != -1) {
                var i = searchById(store.products, producto);

                if (store.products[i].agregados) {
                    store.products[i].extras = null;
                }
                if (store.products[i].sabores) {
                    store.products[i].selsabores = null;
                }
            }
        };

        var removeProducto = function(producto) {
            var i, carrito = this;

            if (producto.cantidad < 1 || producto.cantidad == undefined )
                return;

            if (producto.agregados.length > 0 || producto.sabores.length > 0) {
                i = searchById(carrito.data.products, producto);
                producto = carrito.data.products[i];
            }

            producto.cantidad--;
            carrito.data.total -= producto.precio;

            if (producto.cantidad == 0) {
                i = carrito.data.products.indexOf(producto);
                carrito.data.products.splice(i, 1);
            }

            carrito.data.cantidad--;
        };

        var addCombo = function(combo) {
            var carrito = this;
            combo = JSON.parse(JSON.stringify(combo));

            carrito.data.cantidad++;
            carrito.data.total += combo.precio;

            combo.cantidad = 1;
            carrito.data.combos.push(combo);
        };

        var removeCombo = function(combo) {
            var carrito = this;
            var i = carrito.data.combos.indexOf(combo);
            combo.cantidad--;
            carrito.data.total -= combo.precio;
            carrito.data.combos.splice(i, 1);
            carrito.data.cantidad--;
        };

        var removeComboByID = function(combo) {
            var carrito = this;
            var i;
            while ((i = searchById(carrito.data.combos, combo)) != -1) {
                combo = carrito.data.combos[i];

                combo.cantidad--;
                carrito.data.total -= combo.precio;
                carrito.data.combos.splice(i, 1);
                carrito.data.cantidad--;
                i = searchById(carrito.data.combos, combo)
            }
        };

        var reiniciar = function(store_id) {
            var data = {
                products: [],
                combos: [],
                total: 0,
                cantidad: 0
            };
            if (store_id) {
                data.local = store_id;
            }
            this.data = data;
        };

        return {
            data: data,
            addProducto: addProducto,
            removeProducto: removeProducto,
            addCombo: addCombo,
            removeCombo: removeCombo,
            removeComboByID: removeComboByID,
            reiniciar: reiniciar
        };
    });

    myApp.filter('sumByKey', function () {
        return function (data, key) {
            if (typeof (data) === 'undefined' || typeof (key) === 'undefined') {
                return 0;
            }

            var sum = 0;
            for (var i = data.length - 1; i >= 0; i--) {
                sum += parseInt(data[i][key]);

            }

            return sum;
        };
    });

    myApp.filter('abs', function() {
        return function(input) {
            return Math.abs(input);
        };
    });

    function _waitForAnalytics(){
        if(window.analytics != null){
            window.analytics.debugMode();
            window.analytics.startTrackerWithId('UA-57967814-1');
            window.analytics.trackView('Login');
        }
        else{
            setTimeout(function(){
                _waitForAnalytics();
            },250);
        }
    }

    if(window.analytics==null){
        _waitForAnalytics();
    }

    myApp.controller('LockController', ['$scope', '$http', 'store', 'usuario', 'sharedProperties',
        function ($scope, $http, store, usuario, sharedProperties) {

        $scope.openURL = function (urlString) {
            //navigator.app.loadUrl(urlString, {openExternal: true});
            window.open(urlString, '_system');
        };
    }]);

    /* Control de Seleccion de Local */
    myApp.controller('LocalController', ['$scope', '$http', 'store', 'usuario', 'sharedProperties',
        function ($scope, $http, store, usuario, sharedProperties) {
        //Funcion que trae los datos de los menus de cierto local
        $scope.user = usuario.value;
        $scope.ubicacion = usuario.ubicacion;
        $scope.search_query = "";
        $scope.noHayLocales = true;
        $scope.modal = false;
        $scope.urlimg = STATICURL + '/static/media/';
        $scope.ingresandoPromo = false;

        var coneccion = true;

        /*$scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/

        $scope.openURL = function (urlString) {
            window.open(urlString, '_system');
        };

        $scope.getVersion = function () {
        if (device.platform=="Android"){
            var keyVersion = '?clave=versionAndroid';
        } else if(device.platform=="iOS"){
            var keyVersion = '?clave=versionIOS';
        } else {
            var keyVersion = '?clave=versionAndroid';
        }

        $http.get(URL + '/config/' + keyVersion)
            .success(function (data, status, headers, config) {
                $scope.versionconfig = data.results[0].contenido;
                if ($scope.versionconfig > version) {
                    //	modalversion.show();
                    onsnavigator.pushPage('lock.html', {animation: "fade"});
                }

            })
            .error(function (data, status, headers, config) {
                console.error('Error de conexion con el servidor')
            });
        };

        $scope.rubros = [];
        if (sharedProperties.getValue('rubro')) {
            $scope.rubro = sharedProperties.getValue('rubro');
        } else {
            $scope.rubro = null;
        }

        $scope.getRubros = function () {
            if($scope.rubros.length>0) return;
            $http.get(URL + '/rubros/')
            .success(function (data, status, headers, config) {
                $scope.rubros = [{"id": "0", "desc": "Todos", "image": ""},];
                $scope.rubros = $scope.rubros.concat(data.results);
            })
            .error(function (data, status, headers, config) {
                // called asynchronously if an error occurs
                // or server returns response with an error status.
                console.log("Error inesperado al obtener rubros");
            });
        };

        $scope.setRubro = function (r) {
            sharedProperties.setValue('rubro', r);
            onsnavigator.pushPage('locales.html', {animation: "fade"});
        };

        $scope.filterLocales = function (query) {
            if (!$scope.noHayLocales) {
                var locales = $scope.localesList;
                if (query.length > 0) {
                    var filtrado = [];
                    for (var i = 0; i < locales.length; i++) {
                        if (locales[i].name.toLowerCase().indexOf(query.toLowerCase()) != -1 ||
                            locales[i].descripcion.toLowerCase().indexOf(query.toLowerCase()) != -1) {
                            filtrado.push(locales[i]);
                        }
                    }
                    $scope.locales = filtrado;
                } else {
                    $scope.locales = locales;
                }
            }
        };

        $scope.getLocales = function () {
            var filt = '';
            if ($scope.rubro != null && $scope.rubro.desc != 'Todos') {
                filt = '&cat=' + $scope.rubro.id;
            }
            if (usuario.ubicacion) {
                filt += '&u=' + usuario.ubicacion.id;
            }

            $http.get(URL + '/negocios/?format=json' + filt)
            .success(function (data, status, headers, config) {
                $scope.getVersion();
                $scope.localesList = data.results;
                $scope.locales = data.results;
                $scope.noHayLocales = false;
            })
            .error(function (data, status, headers, config) {
                // called asynchronously if an error occurs
                // or server returns response with an error status.
                console.log("Error critico:");
                console.log(data);
            });
        };

        $scope.getMenuFromLocal = function (local) {
            //console.clear();
            $scope.modal = false;
            $scope.color4 = local.color4;
            $scope.color1 = local.color1;

            $scope.imgmodal = $scope.urlimg + local.logo;

            var id = local.id;

            store.store = local;

            try{
                modalon.show();
                $scope.$root.hide = "true";
            }
            catch(ex){
                console.log('Error al tratar de mostrar el splash de empresas');
            }

            $scope.getMenuReal(id);
        };

        $scope.registrarAccion = function (local,accion) {
            // registrar el evento al backend
            var data = 'negocio='+local.id+'&accion='+accion;
            $http.post(URL + '/addIteNegocio/', data,
            {
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8'
                }
            })
            .success(function () {
                console.log('Se registro el evento');
            })
            .error(function (rejection) {
                console.log('Reject al registrar un action:');
                console.log(rejection);
            });
        };

        $scope.llamarLocal = function(local){
            $scope.registrarAccion(local,1);
            $scope.openURL('tel:'+local.telefono);
        };

        $scope.ingresarLocal = function(local){
            if (usuario.ubicacion == undefined) {
                swal({
                    title: "Seleccionar destino",
                    text: "Antes de ingresar al negocio debe seleccionar un destino",
                    type: "info",
                    showCancelButton: true,
                    cancelButtonColor: "#008A74",
                    confirmButtonColor: "#008A74",
                    confirmButtonText: "Destinos",
                    cancelButtonText: "Cancelar",
                    closeOnConfirm: true,
                    closeOnCancel: true
                }, function () {
                    onsnavigator.pushPage('ubicacion.html');
                    // por si entro a traves de promos, setea a false
                    $scope.ingresandoPromo = false;
                });
            } else {
                if (local.abierto) {
                    if(local.enrango){
                        $scope.registrarAccion(local,0);
                        $scope.getMenuFromLocal(local);
                    }
                    else{
                        swal({
                            title: "Negocio fuera de alcance",
                            text: "Lo sentimos, " + local.name + " se encuentra fuera del alcance de cobertura. ¿Desea ingresar de igual manera?",
                            type: "info",
                            showCancelButton: true,
                            cancelButtonColor: "#008A74",
                            confirmButtonColor: "#008A74",
                            confirmButtonText: "Ingresar",
                            cancelButtonText: "Cancelar",
                            closeOnConfirm: true,
                            closeOnCancel: true
                        },
                        function (isConfirm) {
                            if (isConfirm) {
                                $scope.registrarAccion(local,0);
                                $scope.getMenuFromLocal(local);
                            }
                        });
                    }
                } else {
                    swal({
                        title: "Negocio cerrado",
                        text: "Lo sentimos, " + local.name + "  se encuentra fuera del horario de atención. ¿Desea ingresar de igual manera?",
                        type: "info",
                        showCancelButton: true,
                        cancelButtonColor: "#008A74",
                        confirmButtonColor: "#008A74",
                        confirmButtonText: "Ingresar",
                        cancelButtonText: "Cancelar",
                        closeOnConfirm: true,
                        closeOnCancel: true
                    },
                    function (isConfirm) {
                        if (isConfirm) {
                            $scope.registrarAccion(local,0);
                            $scope.getMenuFromLocal(local);
                        }
                    });
                }
            }
        };

        $scope.getMenuReal = function (id) {
            $http.get(URL + '/catalogos/?empresa=' + id)
            .success(function (data, status, headers, config) {
                store.data = {"menu": data.results};
                store.data.menu.submenus = data.results;
                $scope.local = store;

                $http.get(URL + '/combos/?negocio=' + id)
                .success(function (data, status, headers, config) {
                    store.combos = data.results;

                    if ($scope.local.padre == null) {
                        store.products = store.data.productos;

                        onsnavigator.pushPage('listadoCatalogos.html');
                    }

                    if (!$scope.modal) {
                        $scope.modalon.hide();
                    }
                })
                .error(function (data, status, headers, config) {
                    // called asynchronously if an error occurs
                    // or server returns response with an error status.
                    console.log("Data:");
                    console.log(data);
                    modalon.hide();
                });
            })
            .error(function (data, status, headers, config) {
                // called asynchronously if an error occurs
                // or server returns response with an error status.
                console.log("Data:");
                console.log(data);
                modalon.hide();
            });
            if (window.analytics != null){
                console.log('Analytics - Ingreso a ' + store.store.name);
                window.analytics.trackView(store.store.name  + ' - Home');
                window.analytics.trackEvent('Ficha de empresa', 'Ver Info', store.store.name, 1);
            }
        };

        $scope.getPromos = function () {
            $scope.noHayPromos = true;

            $http.get(URL + '/promos/')
            .success(function (data, status, headers, config) {
                // this callback will be called asynchronously
                // when the response is available
                $scope.modal = true;
                $scope.promosList = data.results;
                $scope.promos = data.results;
                $scope.noHayPromos = false;
            })
            .error(function (data, status, headers, config) {
                // called asynchronously if an error occurs
                // or server returns response with an error status.
                console.log("Data:");
                console.log(data);
            });
        };

        function getLocalByUrl(url) {
            var aux = url.split("/");
            var id = aux[aux.length - 2];
            for (var i = 0; i < $scope.localesList.length; i++) {
                if (id == $scope.localesList[i].id) {
                    return $scope.localesList[i];
                }
            }

            return null;
        }

        $scope.setPromo = function (p) {
            if($scope.ingresandoPromo) return;
            $scope.ingresandoPromo=true;
            $scope.promo = p;
            store.store = getLocalByUrl(p.empresa)
            $scope.ingresarLocal(store.store);
        };

        $scope.$watch("search_query", function (newValue, oldValue) {
            $scope.filterLocales($scope.search_query);
        });

        $scope.getLocales();
        $scope.getPromos();

        if (window.analytics != null) {
            window.analytics.trackView('Empresas');
            window.analytics.trackEvent('Listado de Empresas', 'Ver');
        }

        $scope.editarperfil = function () {
            onsnavigator.pushPage('editarperfil.html');
        };

        $scope.showAbout = function () {
            swal({
                title: "Delivery+",
                text: '<div style="text-align: left"><p>Emprendimiento de <span style="color:#F14E26; white-space:nowrap;">Sistemas Genéricos S.R.L.</span></p>' +
                '<br /><p>Visite nuestro sitio web deliverymas.com</p>' +
                '<br /><p><small>Industria Paraguaya<br />2015 Todos los derechos reservados</small>.</p></div>',
                html: true,
                confirmButtonColor: "#008A74",
                confirmButtonText: "Cerrar",
                allowOutsideClick: true
            });
        };

        slidemenu.on('preopen', function () {
            $scope.getRubros();
        });
    }]);

    myApp.controller('CatalogoController', ['$scope', '$http', 'store', 'carrito', 'usuario', function ($scope, $http, store, carrito, usuario) {
        var coneccion = true;

        /*$scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            console.log('conecta:', $scope.esta);
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/

        $scope.ubicacion = usuario.ubicacion;

        var imgsrc = STATICURL + '/static/media/';
        var a = store.data;

        if (!carrito.data || !store.store.enrango || (carrito.data && store.store.id != carrito.data.local)) {
            carrito.reiniciar(store.store.id);
        }

        if (a === null || a.hayMenu === false) {
            $scope.menu = {};
        } else {
            $scope.menu = a.menu;
        }

        $scope.empresa = store.store.name;
        $scope.pattern = imgsrc + store.store.pattern;
        $scope.banner = imgsrc + store.store.banner;
        $scope.color1 = store.store.color1;
        $scope.color2 = store.store.color2;
        $scope.color3 = store.store.color3;
        $scope.color4 = store.store.color4;
        $scope.color5 = store.store.color5;
        $scope.desc = store.store.menu;
        $scope.logo = imgsrc + store.store.logo;
        $scope.cantidad_combos = store.combos.length;

        if (usuario.ubicacion == undefined) {
            $scope.lugar = "";
        } else {
            $scope.lugar = usuario.ubicacion.nombre;
        }

        if (!usuario.ubicacion) {
            swal({
                title: "Disculpe",
                text: "Debe seleccionar un destino para realizar la compra",
                type: "warning",
                confirmButtonText: "Aceptar"
            });

            $scope.lugarsi = "No seleccionó destino!";
        }

        $scope.menuPrimerNivel = function(m){
            return angular.isArray(m);
        };

        $scope.cambiarMenu = function (m) {
            if (m.submenus.length != 0) {
                store.data = {"menu": m};
                onsnavigator.pushPage('listadoCatalogos.html');
            }
            else {
                store.products = m.productos;

                for (var i = 0; i < carrito.data.products.length; i++) {
                    var producto = carrito.data.products[i];
                    var i2 = searchById(store.products, producto);
                    if (i2 != -1) {
                        store.products[i2].cantidad = producto.cantidad;
                    }
                }

                store.data = {"menu": m};

                onsnavigator.pushPage('listadoProductos.html');
            }
        };

        $scope.irAListadoCombos = function () {
            onsnavigator.pushPage('listadoCombos.html');
        };

        $scope.$watch(function () {
            return carrito.data
        }, function (newValue, oldValue) {
            $scope.carrito = carrito.data;
        });

        $scope.verDescripcionLocal = function () {
            onsnavigator.pushPage('ficha.html');
        };
    }]);

    myApp.controller('ProductController', ['$scope', '$rootScope', '$sce', '$filter', 'store', 'carrito', 'comboFactory', function ($scope, $rootScope, $sce, $filter, store, carrito, comboFactory) {
        var coneccion = true;

        /*$scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            console.log('conecta:', $scope.esta);
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/

        var imgsrc = STATICURL + '/static/media/';

        if (!carrito.data || !store.store.enrango || (carrito.data && store.store.id != carrito.data.local)) {
            carrito.reiniciar(store.store.id);
        }

        $scope.seleccionados = [];

        $scope.color1 = store.store.color1;
        $scope.color2 = store.store.color2;
        $scope.color3 = store.store.color3;
        $scope.color4 = store.store.color4;
        $scope.color5 = store.store.color5;
        $scope.banner = imgsrc + store.store.banner;

        $scope.pattern = imgsrc + store.store.pattern;
        $scope.carrito = carrito.data;

        $scope.menu = store.data.menu;
        $scope.titulo = $scope.menu.titulo;
        $scope.products = store.products;

        $scope.actualizarCarritoLocal = function () {
            $scope.carrito = carrito.data;
        };

        $scope.detalleProducto = function (prod) {
            if (!prod.descripcion || prod.descripcion.trim().length == 0) {
                return;
            }
            store.data = {"prod": prod};
            onsnavigator.pushPage('descripcion.html');
        };

        $scope.agregadosProducto = function (prod) {
            store.data = {"extras": prod};

            onsnavigator.pushPage('extras.html');
        };

        /*Inicio de Agregado para funcionalidad de selector de sabores*/

        $scope.flavors = onsnavigator.getCurrentPage().options.flavors;

        if ($scope.flavors) {
            $scope.titulo = $scope.flavors.nombre;

            $scope.checked = false;
            var auxslice = 0;
            var maxsabores = $scope.flavors.maxsabores;
            $scope.maxsabores = maxsabores;
            $scope.maxsabores_str = '1 sabor';
            if (maxsabores > 1) {
                $scope.maxsabores_str = 'Hasta {{maxsabores}}<br/>sabores'.replace('{{maxsabores}}', maxsabores);
            }
            $scope.maxsabores_str = $sce.trustAsHtml($scope.maxsabores_str);

            $scope.selectedFlavors = [];
            $scope.slices = [];

        	$scope.lista_sabores = null;
        	if ($scope.flavors.lista_sabores) {
        		var lista_sabores = $scope.flavors.lista_sabores.split(',');
	            for (var i = 0; i < lista_sabores.length; i++) {
	                lista_sabores[i] = parseInt(lista_sabores[i]);
	            }
	            lista_sabores = lista_sabores.sort();
	            $scope.lista_sabores = lista_sabores;
	            $scope.lista_sabores_str = 'Seleccione ' + lista_sabores.join(' / ') + ' sabores';
        	}
            if (maxsabores < 2) {
                $scope.lista_sabores_str = 'Seleccione 1 sabor';
            }
        } else {
            store.combo = null;
        }

        $scope.addFlavor = function (flavor) {
            if ($scope.selectedFlavors.indexOf(flavor) != -1) {
                var i = $scope.selectedFlavors.indexOf(flavor);
                $scope.selectedFlavors.splice(i, 1);
                auxslice--;
            } else {
                if ($scope.selectedFlavors.length <= maxsabores) {
                    $scope.selectedFlavors.push(flavor);
                    auxslice++;
                }
            }

            $scope.slice = auxslice;
        };

        $scope.confirmarSabores = function (flavors) {
            if ($scope.selectedFlavors == 0) {
                swal({
                    title: "Lo sentimos!",
                    text: "Debe elegir al menos un sabor.",
                    type: "warning",
                    confirmButtonText: "Aceptar"
                });
                return;
            } else if ($scope.lista_sabores && $scope.lista_sabores.indexOf($scope.selectedFlavors.length) === -1) {
                swal({
                    title: "Cantidad de sabores no permitida",
                    text: $scope.lista_sabores_str,
                    type: "warning",
                    confirmButtonText: "Aceptar"
                });
                return;
            }

            $rootScope.$on('$locationChangeStart', function (event, newUrl, oldUrl) {
                event.preventDefault(); // This prevents the navigation from happening
            });

            $scope.flavors.selsabores = $scope.selectedFlavors;

            if (store.combo) {
                var ig = store.combo.grupos.indexOf(store.combo.componente_actual.grupo);
                var i = store.combo.grupos[ig].componentes.indexOf(store.combo.componente_actual);
                var componente = store.combo.original.grupos[ig].componentes[i];
                componente = JSON.parse(JSON.stringify(componente));
                componente.cantidad_seleccionada = 1;
                componente.producto.selsabores = $scope.selectedFlavors;

                store.combo.componente_actual.cantidad_seleccionada++;
                store.combo.seleccion.push(componente);
                store.combo.componente_actual = null;
            } else {
                if (!flavors.cantidad)
                    flavors.cantidad = 0;
                flavors.cantidad++;
                carrito.addProducto(flavors);
            }

            $scope.flavors.selsabores = null;
            onsnavigator.popPage();
        };

        $scope.mostrarDescrip = function (detalle) {
            if (detalle.descripcion) {
                var tittle = detalle.nombre;
                var message = detalle.descripcion;
            }
            swal(tittle, message);
        };

        /* Fin de Agregado para funcionalidad de selector de sabores */

        $scope.addItem = function (item) {
            var producto = JSON.parse(JSON.stringify(item));

            if (!store.validarAbiertoEnRango())
                return;

            if (item.sabores.length > 0 &&
                    (!item.selsabores || item.selsabores && item.selsabores.length == 0) && !item.extras) {
                $scope.flavors = item;
                $scope.flavors.selsabores = [];

                if (item.agregados) {
                    $scope.extras = item;
                }

                onsnavigator.pushPage('seleccionarSabores.html', {flavors: $scope.flavors});
            } else if (item.agregados.length > 0 && !item.extras) {
                if (item.selsabores) {
                    carrito.data.products.push(producto);
                    carrito.data.total += item.precio;

                    for (var i = item.selsabores.length - 1; i >= 0; i--) {
                        carrito.data.total += Math.round(item.selsabores[i].precio / item.selsabores.length);
                        producto.precio += Math.round(item.selsabores[i].precio / item.selsabores.length);
                    }
                }

                $scope.extras = item;

                $scope.mandatorio = false;
                $scope.agregar = false;
                $scope.quitar = false;

                for (var j = $scope.extras.agregados.length - 1; j >= 0; j--) {
                    if ($scope.extras.agregados[j].tipo == 2) {
                        $scope.mandatorio = true;
                    } else if ($scope.extras.agregados[j].tipo == 1) {
                        $scope.quitar = true;
                    } else {
                        $scope.agregar = true;
                    }
                    if ($scope.extras.agregados[j].checked) {
                        $scope.extras.agregados[j].checked = false;
                    }
                }

                $scope.extras.extras = null;
                $scope.totalProvisorioProducto = item.precio;

                onsnavigator.pushPage('seleccionarAgregados.html', {item: item})
            } else {
                if (!item.cantidad)
                    item.cantidad = 0;
                item.cantidad++;
                carrito.addProducto(item);
                $scope.actualizarCarritoLocal();
            }
        };

        $scope.preremove = function (item) {
            if (item.agregados.length > 0 || item.sabores.length > 0) {
                for (var h = 0, len = item.cantidad; h < len; h++) {
                    $scope.removeProducto(item);
                }
                item.cantidad = 0;
            } else {
                $scope.removeProducto(item);
            }
        };

        $scope.removeProducto = function (producto) {
            carrito.removeProducto(producto);
            $scope.actualizarCarritoLocal();
        };

        $scope.$watch(function () {
            return carrito.data
        }, function (newValue, oldValue) {
            $scope.carrito = carrito.data;
        });

        $scope.verDescripcionLocal = function () {
            onsnavigator.pushPage('ficha.html');
        };

        $scope.actualizarCarritoLocal();
    }]);

    myApp.controller('AgregadoController', ['$scope', '$rootScope', '$sce', '$filter', 'store', 'carrito', function ($scope, $rootScope, $sce, $filter, store, carrito) {
        var item = onsnavigator.getCurrentPage().options.item;
        $scope.extras = item;

        if (!$scope.extras.cantidad)
            $scope.extras.cantidad = 0;

        $scope.mandatorio = false;
        $scope.agregar = false;
        $scope.quitar = false;

        for (var j = $scope.extras.agregados.length - 1; j >= 0; j--) {
            if ($scope.extras.agregados[j].tipo == 2) {
                $scope.mandatorio = true;
            } else if ($scope.extras.agregados[j].tipo == 1) {
                $scope.quitar = true;
            } else {
                $scope.agregar = true;
            }
            if ($scope.extras.agregados[j].checked) {
                $scope.extras.agregados[j].checked = false;
            }
        }

        $scope.extras.extras = [];
        $scope.totalProvisorioProducto = item.precio;

        $scope.selectAgregados = function (a) {
            for (var j = $scope.extras.agregados.length - 1; j >= 0; j--) {
                if ($scope.extras.agregados[j].id != a.id && $scope.extras.agregados[j].tipo == 2) {
                    $scope.extras.agregados[j].checked = false;
                } else if ($scope.extras.agregados[j].tipo == 2) {
                    $scope.extras.agregados[j].checked = true;
                }
            }
            $scope.recalcularTotal();
        };

        $scope.recalcularTotal = function() {
            $scope.totalProvisorioProducto = $scope.extras.precio;
            for (var j = 0; j <= $scope.extras.agregados.length-1; j++) {
                if ($scope.extras.agregados[j].checked){
                    $scope.totalProvisorioProducto += $scope.extras.agregados[j].precio;
                }
            }
        };

        $scope.confirmarAgregados = function (extras) {
            $scope.seleccionados = $filter('filter')($scope.extras.agregados, {checked: true});

            var select = $scope.seleccionados;
            var si = 0;
            if ($scope.mandatorio) {
                for (var i = $scope.seleccionados.length - 1; i >= 0; i--) {
                    if ($scope.seleccionados[i].tipo == 2) {
                        si++;
                    }
                }
                if (si == 0) {
                    swal({title: "Ups!", text: "Seleccione una opción.", type: "error", confirmButtonText: "Aceptar"});
                    return;
                }
            }
            $scope.extras.extras = select;

            $scope.extras.cantidad++;

            if (store.combo) {
                var ig = store.combo.grupos.indexOf(store.combo.componente_actual.grupo);
                var i = store.combo.grupos[ig].componentes.indexOf(store.combo.componente_actual);
                var componente = store.combo.original.grupos[ig].componentes[i];
                componente = JSON.parse(JSON.stringify(componente));
                componente.cantidad_seleccionada = 1;
                componente.producto.extras = select;

                store.combo.componente_actual.cantidad_seleccionada++;
                store.combo.seleccion.push(componente);
                store.combo.componente_actual = null;
            } else {
                carrito.addProducto($scope.extras);
            }

            onsnavigator.popPage();
        };
    }]);

    myApp.controller('ComboController', ['$scope', '$rootScope', '$sce', '$filter', 'store', 'carrito', 'comboFactory', function ($scope, $rootScope, $sce, $filter, store, carrito, comboFactory) {
        var coneccion = true;

        /*$scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            console.log('conecta:', $scope.esta);
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/

        var imgsrc = STATICURL + '/static/media/';

        $scope.seleccionados = [];

        $scope.color1 = store.store.color1;
        $scope.color2 = store.store.color2;
        $scope.color3 = store.store.color3;
        $scope.color4 = store.store.color4;
        $scope.color5 = store.store.color5;
        $scope.banner = imgsrc + store.store.banner;

        $scope.pattern = imgsrc + store.store.pattern;

        $scope.combos = store.combos;
        $scope.menu = store.data.menu;
        $scope.carrito = carrito.data;

        // Actualizar cantidad para los combos con los del carrito
        for (var i = 0; i < $scope.carrito.combos.length; i++) {
            var combo = $scope.carrito.combos[i];
            var i2 = searchById(store.combos, combo);
            if (i2 != -1)
                if (!store.combos[i2].cantidad)
                    store.combos[i2].cantidad = combo.cantidad;
                else
                    store.combos[i2].cantidad += combo.cantidad;
        }

        $scope.actualizarCarritoLocal = function () {
            $scope.carrito = carrito.data;
        };

        $scope.addCombo = function (combo) {
            if (!store.validarAbiertoEnRango())
                return;

            comboFactory.setCombo(combo);
            store.combo = comboFactory.combo;
            store.combo.componente_actual = null;
            store.combo.seleccion = [];

            $scope.combo = comboFactory.combo;
            $scope.grupo_expandido = $scope.combo.grupos[0];

            modalEditarCombo.show();
        };

        $scope.guardarCombo = function() {
            if (store.combo.cantidad == store.combo.cantidad_seleccionada()) {
                store.combo.original.cantidad++;
                carrito.addCombo(comboFactory.getComboCarrito());
                store.combo = null;
                modalEditarCombo.hide();
            } else {
                swal({
                    title: "Atención!",
                    text: 'Faltan seleccionar productos',
                    type: "warning",
                    confirmButtonText: "Aceptar"
                });
            }
        };

        $scope.removeCombo = function (combo) {
            combo.cantidad = 0;
            carrito.removeComboByID(combo);
            $scope.actualizarCarritoLocal();
        };

        $scope.verDescripcionLocal = function() {
            onsnavigator.pushPage('ficha.html');
        };

        /* Inicio funcionalidad modal */
        $scope.addComponente = function (componente) {
            var producto = componente.producto;
            var grupo = componente.grupo;
            if (grupo.cantidad == grupo.cantidad_seleccionada()) {
                var mensaje = "El " + grupo.nombre + " ya está completo";
                if (grupo.cantidad == 1) {
                    mensaje = "Ya ha seleccionado la " + grupo.nombre;
                }
                swal({
                    title: "Atención!",
                    text: mensaje,
                    type: "warning",
                    confirmButtonText: "Aceptar"
                });
                return;
            }
            //
            store.combo.componente_actual = componente;
            if (producto.sabores.length > 0 && !producto.selsabores && !producto.extras) {
                $scope.flavors = producto;
                $scope.flavors.selsabores = [];

                if (producto.agregados) {
                    $scope.extras = producto;
                }

                onsnavigator.pushPage('seleccionarSabores.html', {flavors: $scope.flavors});
            } else if (producto.agregados.length > 0 && !producto.extras) {
                if (producto.selsabores) {
                    carrito.data.products.push(producto);
                    carrito.data.total += producto.precio;

                    for (var i = producto.selsabores.length - 1; i >= 0; i--) {
                        carrito.data.total += Math.round(producto.selsabores[i].precio / producto.selsabores.length);
                        producto.precio += Math.round(producto.selsabores[i].precio / producto.selsabores.length);
                    }
                }

                $scope.extras = producto;

                $scope.mandatorio = false;
                $scope.agregar = false;
                $scope.quitar = false;

                for (var j = $scope.extras.agregados.length - 1; j >= 0; j--) {
                    if ($scope.extras.agregados[j].tipo == 2) {
                        $scope.mandatorio = true;
                    } else if ($scope.extras.agregados[j].tipo == 1) {
                        $scope.quitar = true;
                    } else {
                        $scope.agregar = true;
                    }
                    if ($scope.extras.agregados[j].checked) {
                        $scope.extras.agregados[j].checked = false;
                    }
                }

                $scope.extras.extras = [];
                $scope.totalProvisorioProducto = producto.precio;

                onsnavigator.pushPage('seleccionarAgregados.html', {extras: producto})
            } else {
                componente.cantidad_seleccionada++;
                if (store.combo.seleccion.indexOf(componente) == -1)
                    store.combo.seleccion.push(componente);
            }
        };

        $scope.removeComponente = function (componente) {
            if (componente.cantidad_seleccionada < 1)
                return;
            componente.cantidad_seleccionada--;
        };

        $scope.detalleProducto = function (item) {
            if (!item.descripcion || item.descripcion.trim().length == 0) {
                return;
            }
            store.data = {"prod": item};
            onsnavigator.pushPage('descripcion.html');
        };
        /* Fin funcionalidad modal */

        /* Inicio funcionalidad grupos expandibles */
        $scope.grupo_expandido = null;

        $scope.expandirGrupo = function(grupo) {
            if ($scope.estaGrupoExpandido(grupo)) {
                $scope.grupo_expandido = null;
            } else {
                $scope.grupo_expandido = grupo;
            }
        };

        $scope.estaGrupoExpandido = function(grupo) {
            return $scope.grupo_expandido == grupo;
        };
        /* Fin funcionalidad grupos expandibles */

        $scope.$watch(function () {
            return carrito.data
        }, function (newValue, oldValue) {
            $scope.carrito = carrito.data;
        });

        $scope.actualizarCarritoLocal();
    }]);

    myApp.controller('DetailController', ['$scope', 'store', 'carrito', function ($scope, store, carrito) {
        var imgsrc = STATICURL + '/static/media/';
        $scope.urlimg = STATICURL + '/static/media/';
        $scope.color1 = store.store.color1;
        $scope.color2 = store.store.color2;
        $scope.color3 = store.store.color3;
        $scope.color4 = store.store.color4;
        $scope.color5 = store.store.color5;
        $scope.detail = store.data.prod;
    }]);

    myApp.controller('ExtrasController', ['$scope', 'store', 'carrito', function ($scope, store, carrito) {
        var imgsrc = STATICURL + '/static/media/';
        $scope.color1 = store.store.color1;
        $scope.color2 = store.store.color2;
        $scope.color3 = store.store.color3;
        $scope.color4 = store.store.color4;
        $scope.color5 = store.store.color5;
        $scope.extras = store.data.extras;
    }]);

    /* Control de Ficha de Local */
    myApp.controller('FichaController', ['$scope', '$http', 'store', 'usuario', 'sharedProperties', function ($scope, $http, store, usuario, sharedProperties) {
        var imgsrc = STATICURL + '/static/media/';
        var iidd = store.store.id;

        var coneccion = true;

        /*$scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            console.log('conecta:', $scope.esta);
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/

        // google analytics
        if(window.analytics != null){
            window.analytics.trackView(store.store.name + ' - Detalle');
            window.analytics.trackEvent('Ficha de empresa', 'Ver Info', store.store.name, 1);
        }

        $scope.openURL = function (urlString) {
            // Solo funcionara en android, para ios lo correcto seria :
            // window.open(url, '_system')
            //navigator.app.loadUrl(urlString, {openExternal: true});
            window.open(urlString, '_system');
        };
        $scope.logo = imgsrc + store.store.logo;
        $scope.ficha = store.store;
    }]);

    myApp.controller('CheckoutController', ['$scope', '$http', 'carrito', 'usuario', 'store', function ($scope, $http, carrito, usuario, store) {
        var imgsrc = STATICURL + '/static/media/';

        $scope.products = store.products;

        if (store.store.tarjeta == false) {
            $scope.tarjeta = 'none';
        } else {
            $scope.tarjeta = '';
        }

        $scope.carrito = carrito.data;
        $scope.envio = store.store.costo;
        $scope.tiempo = store.store.tiempo;
        $scope.banner = imgsrc + store.store.banner;
        $scope.enableEnvio = true;
        $scope.acepta_tarjeta = store.store.tarjeta;
        $scope.tipo_pago = "efectivo";
        $scope.comentario = "";
        $scope.factura = false;
        $scope.razon = usuario.value.razon;
        $scope.ruc = usuario.value.ruc;


        $scope.actualizarCarritoLocal = function () {
            $scope.carrito = carrito.data;
        };

        if (usuario.ubicacion == undefined) {
            $scope.lugar = "";
        } else {
            $scope.lugar = usuario.ubicacion.nombre;
        }

        $scope.removeProducto = function (producto) {
            if (store.products) {
                var i = searchById(store.products, producto);
                if (i != -1)
                    store.products[i].cantidad--;
            }

            carrito.removeProducto(producto);
            $scope.actualizarCarritoLocal();
        };

        $scope.removeCombo = function (combo) {
            var i = searchById(store.combos, combo);
            store.combos[i].cantidad--;

            carrito.removeCombo(combo);
            $scope.actualizarCarritoLocal();
        };

        $scope.mostrarAgregados = function (lista) {
            var message = '';
            var ttipo = '';
            for (var i = lista.length - 1; i >= 0; i--) {
                if (lista[i].tipo == 0) {
                    ttipo = "Agregar - ";
                } else if (lista[i].tipo == 1) {
                    ttipo = "Quitar - ";
                }
                message += ttipo + '\x09' + lista[i].nombre + '\n';
            }
            swal("Detalle", message);
        };

        $scope.mostrarSabores = function (lista) {
            var message = '';
            var ssabor = '';
            for (var i = lista.length - 1; i >= 0; i--) {
                ssabor = "Sabor - ";
                message += ssabor + '\x09' + lista[i].nombre + '\n';
            }
            swal("Detalle", message);
        };

        $scope.mostrarDetalles = function (detalle) {
            var titulo = 'Detalle';
            var message = '';
            if (detalle.seleccion) {
                titulo = 'COMBO: ' + detalle.nombre;
                var seleccion = detalle.seleccion;
                for (var i = 0; i < seleccion.length; i++) {
                    var producto = seleccion[i];
                    message += "• " + producto.cantidad + ' x ' + producto.nombre + '\n';
                    var message_as = getMessageAgregadosSabores(producto);
                    message_as = message_as.split('\n');
                    for (var i2 = 0; i2 < message_as.length; i2++) {
                        message += message_as[i2] + '\n';
                    }
                }
            } else {
                message = getMessageAgregadosSabores(detalle);
                if (message == '')
                    return;
            }
            swal(titulo, message);
        };

        function datosFacturaUpdate(){
            var uid = usuario.value.user;
            var pdata = {
                "ruc": $scope.ruc,
                "razon": $scope.razon
            };
            $http({method: 'PATCH', url: URL + '/perfiles/' + uid + '/', data: pdata})
                .success(function (data, status, headers, config) {
                    console.log('se guardaron los datos de factura')
                    usuario.value.razon = $scope.razon;
                    usuario.value.ruc = $scope.ruc;
                })
                .error(function (data, status, headers, config) {
                    console.log(data);
                    console.log('error al guardar datos de factura')
                });
        }

        $scope.enviarPedido = function () {

            var carro = carrito.data;

            if (!usuario.ubicacion) {
                swal({title: "Error!", text: "Debe elegir un destino!", type: "error", confirmButtonText: "Aceptar"});
                return false;
            }

            if (!carro || carro.cantidad == 0) {
                swal({
                    title: "Atencion!",
                    text: "No hay productos dentro del carrito",
                    type: "warning",
                    confirmButtonText: "Aceptar"
                });
                return false;
            }
            if (carro.total < store.store.minimo) {
                swal({
                    title: "Atencion!",
                    text: "El monto mínimo de pedido es " + store.store.minimo + "",
                    type: "warning",
                    confirmButtonText: "Aceptar"
                });
                return false;
            }

            if (!store.store.abierto) {
                swal({
                    title: "Atencion!",
                    text: "El negocio se encuentra cerrado.",
                    type: "warning",
                    confirmButtonText: "Aceptar"
                });
                return false;
            }

            if ($scope.factura){
                if ($scope.razon.trim() == '' || $scope.ruc.trim() == ''){
                    swal({
                        title: "Atencion!",
                        text: "Debe completar los datos de facturación.",
                        type: "warning",
                        confirmButtonText: "Aceptar"
                    });
                    return false;
                }
                if ($scope.razon != usuario.value.razon || $scope.ruc != usuario.value.ruc)
                    datosFacturaUpdate();
            }

            $scope.enableEnvio = false;
            carro.costo_envio = store.store.costo;

            carro.comentario = $scope.comentario;

            /*var tipo_pago = "efectivo";
            if ($scope.tipo_pago) {
                tipo_pago = "tarjeta";
            }*/

            carro.tipo_pago = $scope.tipo_pago;

            var data = {
                'sucursal': URL + '/sucursales/' + store.store.sucursal.id + '/',
                'json': JSON.stringify(carro),
                'uid': 108,
                'negocio': URL + '/negocios/' + store.store.id + '/',
                'user': URL + '/users/' + usuario.value.user + '/',
                'direccion': URL + '/ubicaciones/' + usuario.ubicacion.id + '/',
                'jubi': JSON.stringify(usuario.ubicacion),
                'estado': 0,
                'costo_envio': carro.costo_envio,
                //'tipo_pago': carro.tipo_pago,
                'extras': carro.extras,
                'total': carro.total + carro.costo_envio,
                'comentario': carro.comentario,
                'forma_pago': $scope.tipo_pago,
                'factura': $scope.factura
            };

            swal({title: "Procesando pedido.", text: "Gracias por su preferencia!", timer: 2000});
            $http.post(URL + '/pedidos/', data)
            .success(function () {
                swal("Enviado con éxito!", "Gracias por su preferencia!", "success");

                carrito.reiniciar();
                $scope.carrito = carrito.data;

                // Ir a estados de pedidos
                tabbar.setActiveTab(2);
            })
            .error(function (rejection) {
                if (rejection.non_field_errors) {
                    swal("Error al guardar", rejection.non_field_errors[0], "error");
                } else {
                    swal("Ha ocurrido un error, intente de nuevo", "", "warning");
                }
                $scope.enableEnvio = true;
            });
        };

        $scope.detalleProducto = function (item) {
            if (!item.descripcion || item.descripcion.trim().length == 0) {
                return;
            }
            store.data = {"prod": item};
            onsnavigator.pushPage('descripcion.html');
        };
    }]);

    myApp.controller('LocationController', ['$scope', '$timeout', '$http', 'usuario', function ($scope, $timeout, $http, usuario) {
        var coneccion = true;

        /*$scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            console.log('conecta:', $scope.esta);
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/
        var map;
        var marker;
        var infowindow;

        $scope.activo = true;
        $scope.location = null;

        Object.toparams = function ObjecttoParams(obj) {
            var p = [];
            for (var key in obj) {
                p.push(key + '=' + obj[key]);
            }
            return p.join('&');
        };

        function placeMarker(location) {
            if (marker == null) {
                marker = new google.maps.Marker({
                    position: location,
                    map: map,
                    animation: google.maps.Animation.DROP
                });
            } else {
                marker.setPosition(location);
                //centra el mapa...
                //map.setCenter(location);
            }

            $scope.location = {'lat': location.lat(), 'lng': location.lng()};
        }

        function initialize() {
            var mapOptions = {
                zoom: 16
            };

            map = new google.maps.Map(document.getElementById('mapa-content'),
                mapOptions);

            //agregado para test de ubicacion sin gps//
            //handleNoGeolocation(false);
            var options = {
                map: map,
                position: new google.maps.LatLng(-25.2869219, -57.5885297),
                //content: content
            };

            //var infowindow = new google.maps.InfoWindow(options);
            map.setCenter(options.position);

            placeMarker(options.position);

            google.maps.event.addListener(map, 'click', function (event) {
                placeMarker(event.latLng);
            });

            //fin de agregado para test ubicacion sin gps//

            // Try HTML5 geolocation
            if (navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(function (position) {
                    var pos = new google.maps.LatLng(position.coords.latitude,
                        position.coords.longitude);
                    map.setCenter(pos);

                    var infowindow = new google.maps.InfoWindow({
                        content: 'Usted esta aqui'
                    });

                    placeMarker(pos);

                    google.maps.event.addListener(marker, 'click', function () {
                        infowindow.open(map, marker);
                    });

                    google.maps.event.addListener(map, 'click', function (event) {
                        placeMarker(event.latLng);
                    });
                }, function () {
                    handleNoGeolocation(true);
                });
            } else {
                // Browser doesn't support Geolocation
                alert("No tiene geolocalización");
                handleNoGeolocation(false);
            }
        }

        function handleNoGeolocation(errorFlag) {
            var content;
            if (errorFlag) {
                content = 'Error: La geolocalización falló. Favor Activar en las opciones del teléfono';
            } else {
                content = 'Error: Tu navegador no soporta geolocalización.';
            }

            var options = {
                map: map,
                position: new google.maps.LatLng(-25.2869219, -57.5885297),
                content: content
            };

            var infowindow = new google.maps.InfoWindow(options);
            map.setCenter(options.position);

            placeMarker(options.position);

            google.maps.event.addListener(map, 'click', function (event) {
                placeMarker(event.latLng);
            });
        }

        //initialize();
        $timeout(function () {
            initialize();
        }, 2000);

        $scope.$watch('nombre', function (newValue, oldValue) {
            if (infowindow) {
                infowindow.setContent($scope.nombre);
            }
        });

        $scope.addUbicacion = function () {
            $scope.activo = false;
            if ($scope.location) {
                var nombre = $scope.nombre;
                var direccion = $scope.direccion;
                var referencia = $scope.referencia;
                var lat = $scope.location.lat;
                var lon = $scope.location.lng;

                if (!nombre) {
                    swal("Ups!", "Ingrese el título de la ubicación.", "warning");
                    $scope.activo = true;
                    return;
                }

                if (!direccion) {
                    swal("Ups!", "Ingrese una dirección.", "warning");
                    $scope.activo = true;
                    return;
                }

                var data = {
                    "user": URL + "/users/" + usuario.value.user + "/",
                    "nombre": nombre,
                    "direccion": direccion,
                    "referencia": referencia,
                    "lat": lat,
                    "lon": lon
                };

                $http.post(URL + '/ubicaciones/', data)
                .success(function (data, status, headers, config) {
                    swal("Genial!", "La ubicación ha sido añadida.", "success");

                    onsnavigator.popPage();
                    onsnavigator.pushPage('ubicacion.html');
                })
                .error(function (data, status, headers, config) {
                    // called asynchronously if an error occurs
                    // or server returns response with an error status.
                    swal("Eror","Ha ocurrido un error, intente de nuevo", "warning");
                    console.log("Data:");
                    console.log(data);
                    $scope.activo = true;
                });
            } else {
                swal("Eror","Ha ocurrido un error, intente de nuevo", "warning");
                $scope.activo = true;
            }
        };

        $scope.editUbicacion = function (u) {
            var id = 70;

            $http.get(URL + '/ubicaciones/' + id + '/')
            .success(function (data, status, headers, config) {
                $scope.locationedit = data;
            })
            .error(function (data, status, headers, config) {
                console.log(data);
                swal("Ha ocurrido un error, intente de nuevo", "", "warning");
            });

            if ($scope.locationedit) {
                var nombre = $scope.nombre;
                var direccion = $scope.direccion;
                var referencia = $scope.referencia;
                var lat = $scope.location.lat;
                var lon = $scope.location.lng;

                var data = {
                    "user": URL + "/users/" + usuario.value.user + "/",
                    "nombre": nombre,
                    "direccion": direccion,
                    "referencia": referencia,
                    "lat": lat,
                    "lon": lon
                }
            }
        }
    }]);

    myApp.controller('Location1Controller', ['$scope', '$timeout', '$http', 'usuario', function ($scope, $timeout, $http, usuario) {
        var coneccion = true;

        var map;
        var marker;
        var defaultPos = new google.maps.LatLng(-25.2869219, -57.5885297);
        var infowindow;

        posicion.nueva = {lat: null, lng: null, titulo: "", direccion: "", referencia: ""};

        $scope.activo = true;
        $scope.location = null;

        Object.toparams = function ObjecttoParams(obj) {
            var p = [];
            for (var key in obj) {
                p.push(key + '=' + obj[key]);
            }
            return p.join('&');
        };

        function initialize() {
            var mapOptions = {
                zoom: 16,
                mapTypeControl: false,
                streetViewControl: false
            };
            map = new google.maps.Map(document.getElementById('mapa-content2'),
                mapOptions);

            if (navigator.geolocation && posicion.actual != null) {
                var pos = new google.maps.LatLng(posicion.actual.latitude, posicion.actual.longitude)
            }else{
                /*swal({
                    title: "Lo sentimos",
                    text: "No hemos encontrado su ubicación actual. Active su GPS y vuelva a intentarlo.",
                    type: "warnign",
                    confirmButtonText: "Aceptar"
                });*/
                var pos = defaultPos;
            }

            google.maps.event.clearListeners(map, 'click');
            google.maps.event.clearListeners(map, 'dblclick');

            google.maps.event.addListener(map,'center_changed',function() {
                if (onsnavigator.getCurrentPage().page == "addLocation1.html") {
                    posicion.nueva.lat = this.getCenter().lat();
                    posicion.nueva.lng = this.getCenter().lng();
                }
            });

            map.setCenter(pos);
            marker = new google.maps.Marker({ position: pos, map: map });
            marker.bindTo('position', map, 'center');
        }

        //initialize();
        $timeout(function () {
            initialize();
        }, 500);

        $scope.$watch('nombre', function (newValue, oldValue) {
            if (infowindow) {
                infowindow.setContent($scope.nombre);
            }
        });

        $scope.confirmarDatos = function (){

            if (posicion.nueva.lat == defaultPos.lat() &&
                posicion.nueva.lng == defaultPos.lng()){
                swal("Ups!", "Debe seleccionar el destino antes de continuar", "warning");
                return;
            }

            var httpClient = new SimpleHttpClient();
            httpClient.get(API_LATLNG + posicion.nueva.lat + ',' + posicion.nueva.lng, function(response) {
                var resp = JSON.parse(response);
                try{
                    posicion.nueva.direccion=resp.results[0].formatted_address;
                }
                catch(e){
                    posicion.nueva.direccion='';
                }
                console.log(posicion.nueva);
                onsnavigator.pushPage('addLocation2.html');
            });
        };

        $scope.editUbicacion = function (u) {
            var id = 70;

            $http.get(URL + '/ubicaciones/' + id + '/')
                .success(function (data, status, headers, config) {
                    $scope.locationedit = data;
                })
                .error(function (data, status, headers, config) {
                    console.log(data);
                    swal("Ha ocurrido un error, intente de nuevo", "", "warning");
                });

            if ($scope.locationedit) {
                var nombre = $scope.nombre;
                var direccion = $scope.direccion;
                var referencia = $scope.referencia;
                var lat = $scope.location.lat;
                var lon = $scope.location.lng;

                var data = {
                    "user": URL + "/users/" + usuario.value.user + "/",
                    "nombre": nombre,
                    "direccion": direccion,
                    "referencia": referencia,
                    "lat": lat,
                    "lon": lon
                }
            }
        }
    }]);

    myApp.controller('Location2Controller', ['$scope', '$timeout', '$http', 'usuario', function ($scope, $timeout, $http, usuario) {
        $scope.activo = true;
        $scope.titulo = posicion.nueva.titulo;
        $scope.direccion = posicion.nueva.direccion;
        $scope.referencia = posicion.nueva.referencia;

        $scope.addUbicacion = function () {
            $scope.activo = false;

            var nombre = $scope.titulo;
            var direccion = $scope.direccion;
            var referencia = $scope.referencia;
            var lat = posicion.nueva.lat;
            var lon = posicion.nueva.lng;

            if (!nombre) {
                swal("Ups!", "Ingrese el título de la ubicación.", "warning");
                $scope.activo = true;
                return;
            }

            if (!direccion) {
                swal("Ups!", "Ingrese una dirección.", "warning");
                $scope.activo = true;
                return;
            }

            if (direccion.match(/\d+/g) == null && referencia.match(/\d+/g) == null) {
                swal("Ups!", "Debe ingresar el número de la casa, edificio u oficina en el campo Dirección o Referencia.", "warning");
                $scope.activo = true;
                return;
            }

            var data = {
                "user": URL + "/users/" + usuario.value.user + "/",
                "nombre": nombre,
                "direccion": direccion,
                "referencia": referencia,
                "lat": lat,
                "lon": lon
            };

            $http.post(URL + '/ubicaciones/', data)
                .success(function (data, status, headers, config) {
                    swal("Genial!", "La ubicación ha sido añadida.", "success");
                    onsnavigator.resetToPage('locales.html');
                    onsnavigator.pushPage('ubicacion.html');
                })
                .error(function (data, status, headers, config) {
                    // called asynchronously if an error occurs
                    // or server returns response with an error status.
                    swal("Eror","Ha ocurrido un error, intente de nuevo", "warning");
                    console.log("Data:");
                    console.log(data);
                    $scope.activo = true;
                });

        };
    }]);

    myApp.controller('LoginController', ['$scope', '$http', 'usuario', 'sharedProperties','$timeout', function ($scope, $http, usuario, sharedProperties, $timeout) {
        //$http.defaults.headers.common["Authorization"] = 'Token ' + token;
        //$http.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
        $scope.ingresando = false;

        function registrarPush(){
            var applicationId = "ub6IZ6O0uQY74ToX2RKPrFLJMM8zi9TJCvytAgBH";
            var clientKey = "zoUKOn6ZNZgYnSvEVJqTlH2BtIbyOzzxzMJIQe3Y";

            window.parsepushnotification.setUp(applicationId, clientKey);
        }

        var coneccion = true;

        /*$scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            console.log('conecta:', $scope.esta);
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/

        $scope.logged = false;
        $scope.recover = STATICURL + '/recover/';

        function isLogged() {
            var uid = localStorage.getItem("uid");
            var token = localStorage.getItem("token");

            if (uid) {
                $scope.logged = true;
                $http.defaults.headers.common["Authorization"] = 'Token ' + token;
                $http.defaults.headers.common["Accept"] = 'application/json; version=' + version;
                setUser(uid);
            }
        }

        $scope.openURL = function (urlString) {
            console.log(urlString);
            //navigator.app.loadUrl(urlString, {openExternal: true});
            window.open(urlString, '_system');
        };

        function setUser(uid) {
            var lpc = localStorage.getItem("lastProfileCheck");
            var dateTimeNow = (new Date()).getTime();
            if(lpc!=null && usuario.value != null){
                if((dateTimeNow-lpc)<profileTimeValid){
                    // no quitar porque sin esto no funciona, cosas del demonio. CUIDADO!
                    $timeout(function () {
                        sharedProperties.setValue('rubro', null);
                        onsnavigator.pushPage('locales.html', {animation: 'none'});
                    }, 0);
                    return;
                }
            }
            $http.get(URL + '/perfiles/' + uid + '/')
            .success(function (data, status, headers, config) {
                localStorage.setItem("lastProfileCheck",(new Date()).getTime());
                usuario.value = data;
                //
                if (data.ubicacion) {
                    usuario.ubicacion = data.ubicacion;
                }
                //
                sharedProperties.setValue('rubro', null);
                onsnavigator.pushPage('locales.html', {animation: 'none'});
                // google analytics asigna usuario
                if(window.analytics != null) {
                    window.analytics.setUserId(String(uid));
                }
            })
            .error(function (data, status, headers, config) {
                console.log("ERROR!:");
                console.log(data);
                $timeout(function () {
                    setUser(uid);
                }, 100);
            });
        }

        $scope.username = "";
        $scope.password = "";
        $scope.login = function () {
            $scope.ingresando = true;
            Object.toparams = function ObjecttoParams(obj) {
                var p = [];
                for (var key in obj) {
                    p.push(key + '=' + obj[key]);
                }
                return p.join('&');
            };

	    if($scope.username == undefined){
	        swal({
                    title: "Error!",
                    text: "El email ingresado no es válido",
                    type: "error",
                    confirmButtonText: "Aceptar"
                });
                $scope.ingresando = false;
                return;
            }

            var user = $scope.username.toLowerCase();
            var pass = $scope.password;

            if(user=='' || pass==''){
                swal({
                    title: "Error!",
                    text: "Por favor complete su email y contraseña",
                    type: "error",
                    confirmButtonText: "Aceptar"
                });
                $scope.ingresando = false;
                return;
            }

            var data = Object.toparams({
                'username': encodeURIComponent(user),
                'password': encodeURIComponent(pass)
            });

            $http.post(URL + '/logtok/', data, {
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8'
                }
            })
            .success(function (data, status, headers, config) {
                if (data.token) {
                    $http.defaults.headers.common["Authorization"] = 'Token ' + data.token;
                    var uid = data.uid;
                    localStorage.setItem("uid", uid);
                    localStorage.setItem("token", data.token);
                    setUser(uid)
                } else {
                    swal({
                        title: "Error!",
                        text: "Respuesta desconocida del servidor",
                        type: "error",
                        confirmButtonText: "Aceptar"
                    });
                }
                $scope.ingresando = false;

            })
            .error(function (data, status, headers, config) {
                // called asynchronously if an error occurs
                // or server returns response with an error status.
                console.log("Data:");
                if(status==401){
                    swal({
                        title: "Error!",
                        text: "Usuario o Password incorrecto",
                        type: "warning",
                        confirmButtonText: "Aceptar"
                    });
                }
                else{
                    swal({
                        title: "Error!",
                        text: "No se pudo conectar con el servidor",
                        type: "error",
                        confirmButtonText: "Aceptar"
                    });
                }
                $scope.ingresando = false;
            });
        };
        isLogged();

        function actualizar_ubicacion(){
            navigator.geolocation.watchPosition(function (position) {
                posicion.actual = position.coords;
                console.log('ubicacion: ' + position.coords.latitude + ',' + position.coords.longitude );
            }, function (error) {
                console.log(error.message);
            }, { timeout: 5000 , enableHighAccuracy: false});
        }

        if ($scope.logged && posicion.actual == null){
            actualizar_ubicacion();
        }else{
            console.log(posicion);
        }
    }]);

    myApp.controller('ProfileController', ['$scope', 'usuario', function ($scope, usuario) {
        $scope.usuario = usuario.value;

        $scope.editarperfil = function () {
            onsnavigator.pushPage('editarperfil.html');
        };

        $scope.resetpass = function () {
            onsnavigator.pushPage('resetpass.html');
        };

        $scope.logout = function () {
            swal({
                title: "¿Seguro?",
                text: "¿Esta seguro que quiere cerrar sesión?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#008A74",
                confirmButtonText: "Cerrar sesión",
                cancelButtonText: "Cancelar",
                closeOnConfirm: true
            }, function () {
                localStorage.removeItem('uid');
                tabbar.setActiveTab(0);
                //$scope.ubicacion = '';
                usuario.value = null;
                usuario.ubicacion = null;
                //localStorage.removeItem('usuario.ubicacion');
            });
        };

        $scope.test = function () {
            onsnavigator.pushPage('addLocation.html');
        };
        $scope.test = function () {
            onsnavigator.pushPage('editLocation.html');
        };
        $scope.delubicacion = function () {
            onsnavigator.pushPage('delubicacion.html');
        };
        $scope.nosotros = function () {
            window.open('http://www.deliverymas.com/', '_system');
        }
    }]);

    myApp.controller('RegistroController', ['$scope', '$http', 'usuario', function ($scope, $http, usuario) {
        var coneccion = true;
        $scope.sms = true;

        $scope.enableEnvio = true;

        /*$scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            console.log('conecta:', $scope.esta);
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/

        $scope.registrar = function () {
            $scope.enableEnvio = false;

            var nombre = $scope.nombre;
            var apellido = $scope.apellido;
            var celular = $scope.celular;
            var ci = $scope.ci;
            var razon = $scope.razon;
            var ruc = $scope.ruc;
            var username = $scope.username.toLowerCase();
            var password = $scope.password;
            var sms = $scope.sms;

            if (!nombre) {
                swal("Ups!", "Ingrese un nombre.", "warning");
                $scope.enableEnvio = true;
                return;
            }

            if (!apellido) {
                swal("Ups!", "Ingrese un apellido.", "warning");
                $scope.enableEnvio = true;
                return;
            }

            if (!celular) {
                swal("Ups!", "Ingrese un número de celular válido\n [09xx xxx xxx].", "warning");
                $scope.enableEnvio = true;
                return;
            }

            var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

            if (!username || !re.test(username)) {
                swal("Ups!", "Ingrese un email válido.", "warning");
                $scope.enableEnvio = true;
                return;
            }

            if (!password) {
                swal("Ups!", "Ingrese un password.", "warning");
                $scope.enableEnvio = true;
                return;
            }

            if (document.getElementById('pass').value != document.getElementById('pass_conf').value) {
                //document.getElementById('pass_conf').setCustomValidity('Passwords must match.');
                swal("Ups!", "La confirmación de contraseña no coincide.", "warning");
                $scope.enableEnvio = true;
                return;
            }
            document.getElementById('pass').setCustomValidity('');

            var data = {
                'username': username,
                'password': password
            };

            $http.post(URL + '/users/', data)
            .success(function (data, status, headers, config) {
                if (data.id) {
                    var uid = data.id;
                    localStorage.setItem("uid", uid);

                    var pdata = {
                        "nombre": nombre,
                        "apellido": apellido,
                        "genero": "",
                        "nacimiento": null,
                        "telefono": celular,
                        "ruc": ruc,
                        "razon": razon,
                        "ci": ci,
                        "sms": sms,
                        "cercanos": false
                    };

                    $http.put(URL + '/perfiles/' + uid + '/', pdata)
                        .success(function (data, status, headers, config) {
                            usuario.value = data;

                            Object.toparams = function ObjecttoParams(obj) {
                                var p = [];
                                for (var key in obj) {
                                    p.push(key + '=' + obj[key]);
                                }
                                return p.join('&');
                            };

                            var data = Object.toparams({
                                'username': encodeURIComponent(username),
                                'password': encodeURIComponent(password)
                            });

                            $http.post(URL + '/logtok/', data, {
                                headers: {
                                    'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8'
                                }
                            })
                            .success(function (data, status, headers, config) {
                                if (data.token) {
                                    $http.defaults.headers.common["Authorization"] = 'Token ' + data.token;
                                    localStorage.setItem("token", data.token);
                                    swal("Enviado con éxito!", "Gracias por registrarse!", "success");

                                    $scope.enableEnvio = true;

                                    // Ir a listado de empresas
                                    tabbar.setActiveTab(0);
                                }
                            })
                            .error(function (data, status, headers, config) {
                                console.log(data);
                                $scope.enableEnvio = true;
                                swal("Error", "Lo sentimos, ha ocurrido un error.", "error");
                            });
                        })
                        .error(function (data, status, headers, config) {
                            console.log(data);
                            $scope.enableEnvio = true;
                            swal("Error", "Lo sentimos, ha ocurrido un error.", "error");
                        });
                }
            })
            .error(function (data, status, headers, config) {
                // called asynchronously if an error occurs
                // or server returns response with an error status.
                console.log("Data error:");
                console.log(data.username);
                if (data.username == "Ya existe Usuario con este Nombre de usuario.") {
                    swal({
                        title: "Error!",
                        text: "Ya existe un Usuario registrado con este email!",
                        type: "error",
                        confirmButtonText: "Aceptar"
                    });
                }
                $scope.enableEnvio = true;
            });
    }
    }]);

    myApp.controller('PosRControl', ['$scope', 'usuario', function ($scope, usuario) {
        $scope.usuario = usuario.value;

        $scope.goBack = function () {
            onsnavigator.popPage();
            //onsnavigator.resetToPage('login.html', {'animation': 'none'});
        }
    }]);

    myApp.controller('RankController', ['$scope', '$http', '$sce', 'store', 'usuario', function ($scope, $http, $sce, store, usuario) {
        var coneccion = true;

        /*$scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            console.log('conecta:', $scope.esta);
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/

        //$scope.comentario = "";

        var id = onsnavigator.getCurrentPage().options.rid;
        var ped = onsnavigator.getCurrentPage().options.ped;
        var star = "";

        $scope.rid = id;
        //$scope.star = '<div><ons-icon icon="fa-star" fixed-width="false" style="color: red">a</ons-icon></div>';
        for (var i = 1; i <= 5; i++) {
            if (i <= id) {
                star = star + '<ons-icon><i class="fa fa-star" style="color: yellow"></i></ons-icon>';
            } else {
                star = star + '<ons-icon><i class="fa fa-star"></i></ons-icon>';
            }
        }
        $scope.rank = star;
        $scope.ranking = $sce.trustAsHtml($scope.rank);

        $scope.calificar = function () {
            var comentario = $scope.comentario;

            $http({method: 'PATCH', url: URL + '/pedidos/' + ped + '/', data: {'rating': id, 'comentario': comentario}})
            .success(function (data, status, headers, config) {
                swal("Gracias!", "Pedido Calificado con éxito.", "success");
                onsnavigator.popPage();
                //onsnavigator.resetToPage('login.html', {'animation': 'none'});
            })
            .error(function (data, status, headers, config) {
                console.log(data);
                swal({
                    title: "Error!",
                    text: "Mmmm ... intenta de nuevo",
                    type: "error",
                    confirmButtonText: "Aceptar"
                });
            });
        }
    }]);

    myApp.controller('PedidoController', ['$scope', '$http', '$sce', 'store', '$interval', 'usuario', 'carrito', function ($scope, $http, $sce, store, $interval, usuario, carrito) {
        var coneccion = true;
        $scope.usuario = usuario.value;
        //if(!($scope.$watch('online', function(newStatus) {  }))){onsnavigator.pushPage('page2.html', { animation: "fade" });}

        /*$scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            console.log('conecta:', $scope.esta);
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/

        var estados = [
            ['Pendiente de confirmación', '#ff0000'],
            ['Recibido por la empresa', '#ff9900'],
            ['En Proceso', '#273995'],
            ['Enviado al cliente', '#008a74'],
            ['Entregado', '#379CA9'],
            ['Cancelado', '#403e41']
        ];
        var uid = usuario.value.user;
        var pedido = null;
        $scope.imgsrc = STATICURL + '/static/media/';
        $scope.pedidosT = [];
        $scope.pedidos = [];
        $scope.negocios = [];
        $scope.cargando = false;

        $scope.mostrarAgregados = function (lista) {
            var message = '';
            var ttipo = '';
            for (var i = lista.length - 1; i >= 0; i--) {
                if (lista[i].tipo == 0) {
                    ttipo = "Agregar - ";
                } else if (lista[i].tipo == 1) {
                    ttipo = "Quitar - ";
                }
                message += ttipo + '\x09' + lista[i].nombre + '\n';
            }
            swal("Detalle", message);
        };

        $scope.mostrarSabores = function (lista) {
            var message = '';
            var ssabor = '';
            for (var i = lista.length - 1; i >= 0; i--) {
                ssabor = "Sabor - ";
                message += ssabor + '\x09' + lista[i].nombre + '\n';
            }
            swal("Detalle", message);
        };

        function getNegocios() {
            $http.get(URL + '/negocios/')
            .success(function (data, status, headers, config) {
                if (data.results) {
                    $scope.negocios = data.results;
                    // solicita los pedidos
                    pedir();
                }
            })
            .error(function (data, status, headers, config) {
                console.log(data);
            });
        }

        $scope.noHayPedidos = true;
        function pedir() {
            if ($scope.negocios.length==0){
                // todavia no se tiene cargada la lista de negocios, retorna
                return;
            }
            $http.get(URL + '/pedidos/?user=' + uid)
            .success(function (data, status, headers, config) {
                if (data) {
                    var pedidos = data;
                    var limit = 5;
                    for (var i = 0; i < limit && i < pedidos.length; i++) {
                        rellenarNegocio(pedidos[i], i == (pedidos.length - 1));
                    }
                    $scope.pedidos = $scope.pedidosT;
                }
                $scope.noHayPedidos = false;
            })
            .error(function (data, status, headers, config) {
                console.log('error en pedidos', data);
                $scope.noHayPedidos = false;
            });
        }

        function isInScope(p) {
            for (var i = 0; i < $scope.pedidosT.length; i++) {
                if ($scope.pedidosT[i].id == p.id) {
                    $scope.pedidosT[i] = p;
                    return true;
                }
            }
            return false
        }

        function rellenarNegocio(p) {
            if ($scope.negocios) {
                var aux = p.negocio.split("/");
                var id = aux[aux.length - 2];
                for (var i = 0; i < $scope.negocios.length; i++) {
                    var data = $scope.negocios[i];
                    if (id == data.id) {
                        p.negocio = data;
                        p.estado = estados[p.estado];
                        p.ped = data.id;
                        break;
                    }
                }
                if (!isInScope(p)) {
                    $scope.pedidosT.push(p);
                }
            }
        }

        $scope.thread = null;
        $scope.getPedidos = function () {
            getNegocios();
            pedir();
            //$scope.thread = $interval(pedir, 5000);
        };

        $scope.verRank = function (id, ped) {
            //modalranking.show();
            $scope.rid = 'hola';
            onsnavigator.pushPage('ranking.html', {rid: id, ped: ped});
            $scope.rid = id;
            //onsnavigator.pushPage('ranking.html');
        };

        $scope.verDetalle = function (p) {
            var detalle = p.json;
            var numpedido = p.id;
            var tiempo = p.negocio.tiempo;
            var estado = p.estado;
            var rating = p.rating;
            var go = true;
            while (go) {
                detalle = JSON.parse(detalle);
                if (typeof detalle == 'string' || detalle instanceof String) {
                    go = true;
                    if (detalle == 'Object {}') {
                        detalle = null;
                        go = false;
                        break;
                    }
                }
                else {
                    go = false;
                    break;
                }

            }

            $scope.pedido = p;

            $scope.tipo_pago = p.forma_pago == undefined ?
                detalle.tipo_pago : p.forma_pago;
            $scope.total = p.total;
            $scope.envio = detalle.costo_envio;
            $scope.tiempo = tiempo;
            $scope.detalle = detalle;
            $scope.numpedido = numpedido;
            $scope.comentario = p.comentario;
            if ((estado[0] == 'Entregado' || estado[0] == 'Cancelado' ) && !rating) {
                $scope.ratingsi = false;
            } else {
                $scope.ratingsi = true;
            }
            $scope.numest = p;

            if ($scope.ratingsi) {
                var star = "";
                for (var i = 1; i <= 5; i++) {
                    if (i <= rating) {
                        star = star + '<ons-icon><i class="fa fa-star" style="color: yellow"></i></ons-icon>';
                    } else {
                        star = star + '<ons-icon><i class="fa fa-star"></i></ons-icon>';
                    }
                }
                $scope.rank = star;
                $scope.calificacion = $sce.trustAsHtml($scope.rank);

            }
            modaldetalle.show();
        };

        /*   INICIO -- VER COMO ENCAPSULAR, FUNCIONAMIENTO SIMILAR SQUE LOCALCONTROLLER   */
        $scope.getMenuFromLocalRepe = function (local) {
            $scope.modal = false;
            $scope.color4 = local.color4;
            $scope.color1 = local.color1;
            $scope.imgmodal = $scope.urlimg + local.logo;
            var id = local.id;
            store.store = local;
            $scope.getMenuRealRepe(id);
        };

        $scope.llamarLocal = function (local) {
            // registrar el evento al backend
            //llamar
            $scope.openURL('tel:'+local.telefono);

        };

        $scope.registrarAccion = function (local,accion) {
            // registrar el evento al backend
            var data = 'negocio='+local.id+'&accion='+accion;
            $http.post(URL + '/addIteNegocio/', data,
            {
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8'
                }
            })
            .success(function () {
                console.log('se registro el evento');
            })
            .error(function (rejection) {
                console.log(rejection);
            });
        };

        $scope.ingresarLocalRepe = function(local){
            if (usuario.ubicacion == undefined) {
                swal({
                    title: "Seleccionar destino",
                    text: "Antes de repetir el pedido debe seleccionar un destino",
                    type: "info",
                    showCancelButton: true,
                    cancelButtonColor: "#008A74",
                    confirmButtonColor: "#008A74",
                    confirmButtonText: "Destinos",
                    cancelButtonText: "Cancelar",
                    closeOnConfirm: true,
                    closeOnCancel: true
                }, function () {
                    onsnavigator.pushPage('ubicacion.html');
                });
            } else {
                if (local.abierto) {
                    if(local.enrango){
                        $scope.registrarAccion(local,0);
                        /*$scope.$root.hide = "true";*/
                        $scope.getMenuFromLocalRepe(local);
                    }
                    else{
                        swal({
                                title: "Negocio fuera de alcance",
                                text: "Lo sentimos, " + local.name + " se encuentra fuera del alcance de cobertura.",
                                type: "info",
                                confirmButtonColor: "#008A74",
                                confirmButtonText: "Aceptar",
                                closeOnConfirm: true
                            });
                    }
                }
                else{
                    swal({
                            title: "Negocio cerrado",
                            text: "Lo sentimos, " + local.name + "  se encuentra fuera del horario de atención.",
                            type: "info",
                            confirmButtonColor: "#008A74",
                            confirmButtonText: "Aceptar",
                            closeOnConfirm: true
                        });
                }
            }
        };

        $scope.getMenuRealRepe = function (id) {
            //$http.get('http://localhost/work/apidelivery/apimenu.php?id='+id_local)
            //$http.get('http://maugavilan.com/apidelivery/apimenu.php?id='+id)
            $http.get(URL + '/negocios/' + id + '/?format=json')
                .success(function (data, status, headers, config) {
                    // this callback will be called asynchronously
                    // when the response is available
                    $http.get(URL + '/catalogos/?empresa=' + id)
                    .success(function (data, status, headers, config) {
                        // this callback will be called asynchronously
                        // when the response is available
                        store.data = {"menu": data.results};
                        store.data.menu.submenus = data.results;
                        $scope.local = store;

                        if ($scope.local.padre == null) {
                            store.products = data.results.productos;
                            store.data = {"menu": data.results};
                            // Primero ir a lista de catalogos para evitar problemas de navegacion
                            onsnavigator.pushPage('listadoCatalogos.html');
                            // Ir a checkout
                            onsnavigator.pushPage('page13.html')
                        }
                        /*if (!$scope.modal) {
                            $scope.modalon.hide();
                        }*/
                    })
                    .error(function (data, status, headers, config) {
                        // called asynchronously if an error occurs
                        // or server returns response with an error status.
                        console.log("Data:");
                        console.log(data);
                        //modalon.hide();
                    });
                    if(window.analytics != null){
                        window.analytics.trackView(store.store.name  + ' - Home');
                        window.analytics.trackEvent('Ficha de empresa', 'Ver Info', store.store.name, 1);
                    }
                })
                .error(function (data, status, headers, config) {
                    // called asynchronously if an error occurs
                    // or server returns response with an error status.
                    console.log("Data:");
                    console.log(data);
                    //modalon.hide();
                });
        };
        /*   FIN -- VER COMO ENCAPSULAR, MISMO FUNCIONAMIENTO QUE LOCALCONTROLLER   */

        $scope.volver = function() {
            if ($scope.cargando == true) {
                return;
            }
            modaldetalle.hide();
        };

        $scope.getRepetir = function (pedido) {
            if ($scope.cargando == true) {
                return;
            }
            $scope.cargando = true;
            carrito.reiniciar(pedido.negocio.id);

            var filt = '';
            if (usuario.ubicacion) {
                filt += '&u=' + usuario.ubicacion.id;
            }

            // TODO: OPTIMIZAR ESTE CODIGO A.S.A.P.
            $http.get(URL + '/negocios/' + carrito.data.local + '/?format=json' + filt)
            .success(function (data, status, headers, config) {
                store.store = data;

                $http.get(URL + '/productos/?negocio=' + carrito.data.local)
                .success(function (data, status, headers, config) {
                    store.products = data.results;

                    $http.get(URL + '/combos/?negocio=' + carrito.data.local)
                    .success(function (data, status, headers, config) {
                        store.combos = data.results;

                        $http.post(URL + '/repetir-pedido/', 'pedido_id=' + pedido.id, {
                            headers: {
                                'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8'
                            }
                        })
                        .success(function (data, status, headers, config) {
                            carrito.data.cantidad = data.cantidad;
                            carrito.data.total = data.total;
                            carrito.data.products = data.products;
                            carrito.data.combos = data.combos;
                            $scope.ingresarLocalRepe(store.store);
                            $scope.cargando = false;
                        })
                        .error(function (data, status, headers, config) {
                            swal({
                                title: "Ups!",
                                text: data,
                                type: "warning",
                                confirmButtonText: "Aceptar"
                            });
                            $scope.cargando = false;
                        });
                    })
                    .error(function (data, status, headers, config) {
                        console.log("Data:");
                        console.log(data);
                        swal({
                            title: "Ups!",
                            text: "Ocurrio un error al repetir el pedido",
                            type: "warning",
                            confirmButtonText: "Aceptar"
                        });
                        $scope.cargando = false;
                    });
                })
                .error(function (data, status, headers, config) {
                    console.log("Data:");
                    console.log(data);
                    swal({
                        title: "Ups!",
                        text: "Ocurrio un error al repetir el pedido",
                        type: "warning",
                        confirmButtonText: "Aceptar"
                    });
                    $scope.cargando = false;
                });
            })
            .error(function (data, status, headers, config) {
                console.log("Data:");
                console.log(data);
                //swal("Es probable que el negocio no esté activo actualmente.","","error");
                swal({
                    title: "Ups!",
                    text: "El negocio no está activo actualmente",
                    type: "warning",
                    confirmButtonText: "Aceptar"
                });
                $scope.cargando = false;
            });
        };

        $scope.cancel = function (item) {
            if ($scope.cargando == true) {
                return;
            }

            var pid = item.id;

            swal({
                title: "¿Seguro?",
                text: "¿Realmente desea cancelar su pedido?",
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#008A74",
                confirmButtonText: "Si, cancélalo!",
                cancelButtonText: "No, consérvalo.",
                closeOnConfirm: true
            }, function () {
                modaldetalle.hide();
                $http.get(URL + '/pedidos/' + pid + '/')
                .success(function (data, status, headers, config) {
                    if (data.estado == 0) {
                        $http({method: 'PATCH', url: URL + '/pedidos/' + pid + '/', data: {'estado': 5}})
                        .success(function (data, status, headers, config) {
                            swal("Cancelado!", "Pedido cancelado con éxito.", "success");
                            // Ir a estado de pedidos
                            tabbar.setActiveTab(2);
                            //onsnavigator.resetToPage('login.html', {'animation': 'none'});
                        })
                        .error(function (data, status, headers, config) {
                            console.log(data);
                            swal({
                                title: "Error!",
                                text: "Mmmm ... intenta de nuevo",
                                type: "error",
                                confirmButtonText: "Aceptar"
                            });
                        });
                    } else {
                        swal("Error!", "Su pedido ya fué procesado y no se puede cancelar.", "error");
                    }
                })
                .error(function (data, status, headers, config) {
                    console.log(data);
                });
            });
        };

        $scope.confirmcancel = function (pid) {
            $http({method: 'PATCH', url: URL + '/pedidos/' + pid + '/', data: {'estado': 5}})
            .success(function (data, status, headers, config) {
                swal("Cancelado!", "Pedido cancelado con éxito.", "success");
                onsnavigator.popPage();
            })
            .error(function (data, status, headers, config) {
                console.log(data);
                swal({
                    title: "Error!",
                    text: "Mmmm ... intenta de nuevo",
                    type: "error",
                    confirmButtonText: "Aceptar"
                });
            });
        };

        $scope.mostrarDetalles = function (detalle) {
            var titulo = 'Detalle';
            var message = '';
            if (detalle.seleccion) {
                titulo = 'COMBO: ' + detalle.nombre;
                var seleccion = detalle.seleccion;
                for (var i = 0; i < seleccion.length; i++) {
                    var producto = seleccion[i];
                    message += "• " + producto.cantidad + ' x ' + producto.nombre + '\n';
                    var message_as = getMessageAgregadosSabores(producto);
                    message_as = message_as.split('\n');
                    for (var i2 = 0; i2 < message_as.length; i2++) {
                        message += message_as[i2] + '\n';
                    }
                }
            } else {
                message = getMessageAgregadosSabores(detalle);
                if (message == '')
                    return;
            }
            swal(titulo, message);
        };

        getNegocios();
        $scope.thread = $interval(pedir, 5000);

        $scope.$on('$destroy', function () {
            $interval.cancel($scope.thread);
        });
    }]);

    myApp.controller('UbicacionCtrl', ['$scope', 'usuario', '$http', '$timeout', function ($scope, usuario, $http, $timeout) {
        var coneccion = true;
        $scope.ubiLoading = false;

        /*$scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            console.log('conecta:', $scope.esta);
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/

        $scope.ubicaciones = [];
        $scope.seleccionado = -1;

        function getUbicaciones() {
            var uid = usuario.value.user;
            $http.get(URL + '/ubicaciones/?user=' + uid)
            .success(function (data, status, headers, config) {
                if (data) {
                    $scope.ubicaciones = data;
                    usuario.ubicaciones = data;

                    if (usuario.ubicacion) {
                        $scope.seleccionado = usuario.ubicacion.id;
                    }
                }
                $scope.ubiLoading = true;
            })
            .error(function (data, status, headers, config) {
                console.log(data);
                $scope.ubiLoading = false;
            });
        }

        $scope.selectUbicacion = function (u) {
            usuario.ubicacion = u;
            $scope.seleccionado = u.id;
            onsnavigator.pushPage('locales.html', {animation: 'lift'});
        };

        $scope.isSelected = function (u) {
            if (usuario.ubicacion && usuario.ubicacion != null) {
                if (usuario.ubicacion.id = u.id) {
                    return true;
                }
            }
            return false;
        };

        $scope.goBack = function () {
            onsnavigator.popPage();
            //onsnavigator.resetToPage('locales.html', {'animation': 'none'});
        };

        $scope.removeUbicacion = function (u) {
            swal({
                title: "Eliminar ubicación",
                text: '¿Está seguro que desea eliminar la ubicación "' + u.nombre + '"?"',
                type: "warning",
                showCancelButton: true,
                cancelButtonColor: "#008A74",
                confirmButtonColor: "#008A74",
                confirmButtonText: "Eliminar",
                cancelButtonText: "Cancelar",
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    if (usuario.ubicacion) {
                        if (usuario.ubicacion.id == u.id) {
                            usuario.ubicacion = null;
                        }
                    }
                    $http.delete(URL + '/ubicaciones/' + u.id + '/', u).success(function (data, status, headers, config) {
                        swal("Genial!", "La ubicación ha sido eliminada.", "success");

                        //onsnavigator.pushPage('delubicacion.html');
                        //onsnavigator.pushPage('locales.html');
                        // Ir a locales
                        tabbar.setActiveTab(0);
                    }).error(function (data, status, headers, config) {
                        console.log(data);
                        swal("Ha ocurrido un error, intente de nuevo", "", "warning");
                    });
                }
            });
        };

        $scope.edit = function (u) {
            $scope.ubi = u.id;
            onsnavigator.pushPage('editLocation.html', {ubi: u.id});
        };

        $scope.setUbicacion = function (u) {
            onsnavigator.pushPage('editLocation.html', {ubi: u.id});
        };

        $scope.editUbicacion = function (u) {
            var nombre = $scope.nombre;
            var direccion = $scope.direccion;
            var referencia = $scope.referencia;
            var lat = $scope.location.lat;
            var lon = $scope.location.lng;

            if (!nombre) {
                swal("Ups!", "Ingrese el título de la ubicación.", "warning");
                return;
            }

            if (!direccion) {
                swal("Ups!", "Ingrese una dirección.", "warning");
                return;
            }

            var ldata = {
                "nombre": nombre,
                "direccion": direccion,
                "referencia": referencia,
                "lat": lat,
                "lon": lon
            };

            $http({method: 'PATCH', url: URL + '/ubicaciones/' + u.id + '/', data: ldata})
            .success(function (data, status, headers, config) {
                swal("Genial!", "Ubicación actualizada con éxito.", "success");

                onsnavigator.popPage();
            })
            .error(function (data, status, headers, config) {
                console.log(data);
                swal({
                    title: "Error!",
                    text: "Mmmm ... intenta de nuevo",
                    type: "error",
                    confirmButtonText: "Aceptar"
                });
            });
        };

        getUbicaciones();
    }]);

    myApp.controller('EditController', ['$scope', '$http', 'usuario', function ($scope, $http, usuario) {
        var coneccion = true;

        /*$scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            console.log('conecta:', $scope.esta);
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/

        var uid = usuario.value.user;

        $scope.nombre = usuario.value.nombre;
        $scope.apellido = usuario.value.apellido;
        $scope.celular = usuario.value.telefono;
        $scope.ci = usuario.value.ci;
        $scope.razon = usuario.value.razon;
        $scope.ruc = usuario.value.ruc;
        $scope.sms = usuario.value.sms;
        $scope.cercanos = usuario.value.cercanos;

        $scope.actualizar = function () {

            var nombre = $scope.nombre;
            var apellido = $scope.apellido;
            var celular = $scope.celular;
            var ci = $scope.ci;
            var razon = $scope.razon;
            var ruc = $scope.ruc;
            var username = $scope.username;
            var sms = $scope.sms;
            var cercanos = $scope.cercanos;

            if (!celular) {
                swal("Ups!", "Ingrese un número de celular válido\n [09xx xxx xxx].", "warning");
                return;
            }

            if (!nombre) {
                swal("Ups!", "Ingrese un nombre.", "warning");
                return;
            }

            if (!apellido) {
                swal("Ups!", "Ingrese un apellido.", "warning");
                return;
            }

            var pdata = {
                //"username": username,
                "nombre": nombre,
                "apellido": apellido,
                "telefono": celular,
                "ruc": ruc,
                "ci": ci,
                "razon": razon,
                "sms": sms,
                "cercanos": cercanos
            };

            $http({method: 'PATCH', url: URL + '/perfiles/' + uid + '/', data: pdata})
            .success(function (data, status, headers, config) {
                swal("Enviado con éxito!", "Perfil actualizado con exito!", "success");
                onsnavigator.popPage();

                //se actualizan los valores del store usuario
                usuario.value.nombre = $scope.nombre;
                usuario.value.apellido = $scope.apellido;
                usuario.value.telefono = $scope.celular;
                usuario.value.ci = $scope.ci;
                usuario.value.razon = $scope.razon;
                usuario.value.ruc = $scope.ruc;
                usuario.value.sms = $scope.sms;
                usuario.value.cercanos = $scope.cercanos;

            })
            .error(function (data, status, headers, config) {
                console.log(data);
                swal({
                    title: "Error!",
                    text: "Mmmm ... intenta de nuevo",
                    type: "error",
                    confirmButtonText: "Aceptar"
                });
            });
        }
    }]);

    myApp.controller('PassController', ['$scope', '$http', 'usuario', function ($scope, $http, usuario) {
        var coneccion = true;

       /* $scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            console.log('conecta:', $scope.esta);
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/

        var uid = usuario.value.user;

        $scope.actualizar = function () {
            if (document.getElementById('pass').value != document.getElementById('pass_conf').value) {
                document.getElementById('pass_conf').setCustomValidity('Passwords must match.');
                swal("Ups!", "La confirmación de contraseña no coincide.", "warning");
            } else {
                document.getElementById('pass').setCustomValidity('');

                var password = $scope.password;

                if (!password) {
                    swal("Ups!", "Ingrese un password.", "warning");
                    return;
                }

                password = encodeURIComponent(password);

                $http({method: 'PATCH', url: URL + '/users/' + uid + '/', data: {'password': password}})
                .success(function (data, status, headers, config) {
                    swal("Enviado con éxito!", "Password cambiado con exito", "success");
                    onsnavigator.popPage();
                })
                .error(function (data, status, headers, config) {
                    console.log(data);
                    swal({
                        title: "Error!",
                        text: "Mmmm ... intenta de nuevo",
                        type: "error",
                        confirmButtonText: "Aceptar"
                    });
                });
            }
        }
    }]);

    myApp.controller('EditlocController', ['$scope', '$timeout', '$http', 'usuario', function ($scope, $timeout, $http, usuario) {
        var coneccion = true;

        /*$scope.$watch('online', function (coneccion) {
            $scope.esta = coneccion ? 'anda' : 'no anda';
            console.log('conecta:', $scope.esta);
            if (!coneccion) {
                onsnavigator.pushPage('page2.html', {animation: "fade"});
            }
        });*/

        var id = onsnavigator.getCurrentPage().options.ubi;

        $scope.setUbicacion = function () {
            $http.get(URL + '/ubicaciones/' + id + '/')
            .success(function (data, status, headers, config) {
                $scope.nombre = data.nombre;
                $scope.direccion = data.direccion;
                $scope.referencia = data.referencia;
                $scope.lat = data.lat;
                $scope.lon = data.lon;
            })
            .error(function (data, status, headers, config) {
                console.log(data);
                swal("Ha ocurrido un error, intente de nuevo", "", "warning");
            });

            var map;
            var marker;
            var infowindow;

            $scope.activo = false;
            $scope.location = null;

            Object.toparams = function ObjecttoParams(obj) {
                var p = [];
                for (var key in obj) {
                    p.push(key + '=' + obj[key]);
                }
                return p.join('&');
            };

            function placeMarker(location) {
                if (marker == null) {
                    marker = new google.maps.Marker({
                        position: location,
                        map: map,
                        animation: google.maps.Animation.DROP
                    });
                } else {
                    marker.setPosition(location);
                    //centra el mapa...
                    //map.setCenter(location);
                }

                $scope.location = {'lat': location.lat(), 'lng': location.lng()};
            }

            function initialize() {
                var mapOptions = {
                    zoom: 16
                };

                map = new google.maps.Map(document.getElementById('mapa-content'), mapOptions);

                //agregado para test de ubicacion sin gps//
                //handleNoGeolocation(false);
                var options = {
                    map: map,
                    position: new google.maps.LatLng($scope.lat, $scope.lon),
                    //content: content
                };

                //var infowindow = new google.maps.InfoWindow(options);
                map.setCenter(options.position);

                placeMarker(options.position);

                google.maps.event.addListener(map, 'click', function (event) {
                    placeMarker(event.latLng);
                });

                //fin de agregado para test ubicacion sin gps//
            }

            $timeout(function () {
                initialize();

            }, 2000);

            $scope.$watch('nombre', function (newValue, oldValue) {
                if (infowindow) {
                    infowindow.setContent($scope.nombre);
                }
            });
        };

        $scope.editUbicacion = function () {
            var nombre = $scope.nombre;
            var direccion = $scope.direccion;
            var referencia = $scope.referencia;
            var lat = $scope.location.lat;
            var lon = $scope.location.lng;

            if (!nombre) {
                swal("Ups!", "Ingrese el título de la ubicación.", "warning");
                return;
            }

            if (!direccion) {
                swal("Ups!", "Ingrese una dirección.", "warning");
                return;
            }

            var ldata = {
                "nombre": nombre,
                "direccion": direccion,
                "referencia": referencia,
                "lat": lat,
                "lon": lon
            };

            $http({method: 'PATCH', url: URL + '/ubicaciones/' + id + '/', data: ldata})
            .success(function (data, status, headers, config) {
                swal("Genial!", "Ubicación actualizada con éxito.", "success");
                usuario.ubicacion = data;
                onsnavigator.popPage();
            })
            .error(function (data, status, headers, config) {
                console.log(data);
                swal({
                    title: "Error!",
                    text: "Mmmm ... intenta de nuevo",
                    type: "error",
                    confirmButtonText: "Aceptar"
                });
            });
        };
        $scope.setUbicacion();
    }]);
})();
